﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls;
using Telerik.WinControls.Data;

namespace test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            GridViewDecimalColumn byteColumn = new GridViewDecimalColumn();
            byteColumn.UniqueName = "HiddenByteColumn";
           //byteColumn.FormatString = "{0:##.###} KB";
            byteColumn.HeaderText = "HiddenByteColumn";
            byteColumn.Width = 111;
            byteColumn.DataType = typeof(Decimal);
            //byteColumn.IsVisible = false;

            GridViewTextBoxColumn textColumn = new GridViewTextBoxColumn();
            textColumn.UniqueName = "TextColumn";
            textColumn.HeaderText = "TextColumn";
            textColumn.Width = 111;
            textColumn.AllowSort = false; // this is disabling the sort option for text column

            radGridView1.Columns.Add(byteColumn);
            radGridView1.Columns.Add(textColumn);
            radGridView1.Rows.AddNew();
            radGridView1.Rows.AddNew();
            radGridView1.Rows.AddNew();
            radGridView1.Rows.AddNew();

            this.radGridView1.Rows[0].Cells[0].Value = 120.10;
            this.radGridView1.Rows[1].Cells[0].Value = 20.20;
            this.radGridView1.Rows[2].Cells[0].Value = 20.22;
            this.radGridView1.Rows[3].Cells[0].Value = 22.0;

            this.radGridView1.Rows[0].Cells["TextColumn"].Value = this.radGridView1.Rows[0].Cells["HiddenByteColumn"].Value.ToString() + " KB";
            this.radGridView1.Rows[1].Cells["TextColumn"].Value = this.radGridView1.Rows[1].Cells["HiddenByteColumn"].Value.ToString() + " KB";
            this.radGridView1.Rows[2].Cells["TextColumn"].Value = this.radGridView1.Rows[2].Cells["HiddenByteColumn"].Value.ToString() + " KB";
            this.radGridView1.Rows[3].Cells["TextColumn"].Value = this.radGridView1.Rows[3].Cells["HiddenByteColumn"].Value.ToString() + " KB";

            this.radGridView1.GridBehavior = new SortingByHiddenDecimalColumnBehavior();
        }

        public class SortingByHiddenDecimalColumnBehavior : BaseGridBehavior
        {
            protected override bool OnMouseDownLeft(MouseEventArgs e)
            {
                GridHeaderCellElement headerCellElement = this.GetCellAtPoint(e.Location) as GridHeaderCellElement;

                if (headerCellElement != null)
                {
                    GridViewDataColumn dataColumn = headerCellElement.ColumnInfo as GridViewDataColumn;

                    if (dataColumn.UniqueName == "TextColumn")
                    {
                        GridViewDataColumn hiddenByColumn =this.GridControl.Columns["HiddenByteColumn"];
                        RadSortOrder sortOrder = hiddenByColumn.SortOrder;
                        sortOrder = sortOrder == RadSortOrder.Ascending ? RadSortOrder.Descending : RadSortOrder.Ascending;
                        hiddenByColumn.SortOrder = sortOrder;
                    }
                }

                return base.OnMouseDownLeft(e);
            }

            
            protected GridCellElement GetCellAtPoint(Point mouseLocation)
            {
                RadElement elementUnderMouse = this.GridControl.ElementTree.GetElementAtPoint(mouseLocation);

                while (elementUnderMouse != null)
                {
                    if (elementUnderMouse is GridCellElement)
                    {
                        break;
                    }

                    elementUnderMouse = elementUnderMouse.Parent;
                }

                return elementUnderMouse as GridCellElement;
            }
        }
    }
}
